Index: /pykota/trunk/pykota/ipp.py
===================================================================
--- /pykota/trunk/pykota/ipp.py (revision 2415)
+++ /pykota/trunk/pykota/ipp.py (revision 2416)
@@ -161,17 +161,17 @@
         if not self.parsed :
             return ""
-        buffer = []
-        buffer.append("IPP version : %s.%s" % self.version)
-        buffer.append("IPP operation Id : 0x%04x" % self.operation_id)
-        buffer.append("IPP request Id : 0x%08x" % self.request_id)
+        mybuffer = []
+        mybuffer.append("IPP version : %s.%s" % self.version)
+        mybuffer.append("IPP operation Id : 0x%04x" % self.operation_id)
+        mybuffer.append("IPP request Id : 0x%08x" % self.request_id)
         for attrtype in self.attributes_types :
             attrdict = getattr(self, "%s_attributes" % attrtype)
             if attrdict :
-                buffer.append("%s attributes :" % attrtype.title())
+                mybuffer.append("%s attributes :" % attrtype.title())
                 for key in attrdict.keys() :
-                    buffer.append("  %s : %s" % (key, attrdict[key]))
+                    mybuffer.append("  %s : %s" % (key, attrdict[key]))
         if self.data :            
-            buffer.append("IPP datas : %s" % repr(message.data))
-        return "\n".join(buffer)
+            mybuffer.append("IPP datas : %s" % repr(message.data))
+        return "\n".join(mybuffer)
         
     def dump(self) :    
@@ -180,33 +180,33 @@
            Returns the message as a string of text.
         """    
-        buffer = []
+        mybuffer = []
         if None not in (self.version, self.operation_id, self.request_id) :
-            buffer.append(chr(self.version[0]) + chr(self.version[1]))
-            buffer.append(pack(">H", self.operation_id))
-            buffer.append(pack(">I", self.request_id))
+            mybuffer.append(chr(self.version[0]) + chr(self.version[1]))
+            mybuffer.append(pack(">H", self.operation_id))
+            mybuffer.append(pack(">I", self.request_id))
             for attrtype in self.attributes_types :
                 tagprinted = 0
                 for (attrname, value) in getattr(self, "%s_attributes" % attrtype).items() :
                     if not tagprinted :
-                        buffer.append(chr(self.dictags["%s-attributes-tag" % attrtype]))
+                        mybuffer.append(chr(self.dictags["%s-attributes-tag" % attrtype]))
                         tagprinted = 1
                     if type(value) != type([]) :
                         value = [ value ]
                     for (vtype, val) in value :
-                        buffer.append(chr(self.dictags[vtype]))
-                        buffer.append(pack(">H", len(attrname)))
-                        buffer.append(attrname)
+                        mybuffer.append(chr(self.dictags[vtype]))
+                        mybuffer.append(pack(">H", len(attrname)))
+                        mybuffer.append(attrname)
                         if vtype in ("integer", "enum") :
-                            buffer.append(pack(">H", 4))
-                            buffer.append(pack(">I", val))
+                            mybuffer.append(pack(">H", 4))
+                            mybuffer.append(pack(">I", val))
                         elif vtype == "boolean" :
-                            buffer.append(pack(">H", 1))
-                            buffer.append(chr(val))
+                            mybuffer.append(pack(">H", 1))
+                            mybuffer.append(chr(val))
                         else :    
-                            buffer.append(pack(">H", len(val)))
-                            buffer.append(val)
-            buffer.append(chr(self.dictags["end-of-attributes-tag"]))
-        buffer.append(self.data)    
-        return "".join(buffer)
+                            mybuffer.append(pack(">H", len(val)))
+                            mybuffer.append(val)
+            mybuffer.append(chr(self.dictags["end-of-attributes-tag"]))
+        mybuffer.append(self.data)    
+        return "".join(mybuffer)
             
     def parse(self) :