Index: pykota/trunk/pykota/version.py
===================================================================
--- pykota/trunk/pykota/version.py (revision 2425)
+++ pykota/trunk/pykota/version.py (revision 2432)
@@ -22,5 +22,5 @@
 #
 
-__version__ = "1.23alpha26_unofficial"
+__version__ = "1.23alpha27_unofficial"
 
 __doc__ = "PyKota : a complete Printing Quota Solution for CUPS and LPRng."
Index: pykota/trunk/bin/pkturnkey
===================================================================
--- pykota/trunk/bin/pkturnkey (revision 2420)
+++ pykota/trunk/bin/pkturnkey (revision 2432)
@@ -47,6 +47,6 @@
   -h | --help          Prints this message then exits.
   
-  -d | --dryrun        Doesn't modify the database at all, but instead prints
-                       what it would do.
+  -f | --force         Modifies the database instead of printing what
+                       it would do.
                        
   -u | --uidmin uid    Only adds users whose uid is greater than or equal to
@@ -64,7 +64,9 @@
   $ pkturnkey --uidmin jerome
 
-  Will initialize PyKota's database will all existing printers and
-  create print accounts for all users whose uid is greater than or
-  equal to jerome's one.
+  Will simulate the initialization of PyKota's database will all existing
+  printers and print accounts for all users whose uid is greater than
+  or equal to jerome's one.
+  To REALLY initialize the database instead of simulating it, please
+  use the -f | --force command line switch.
 """)
         
@@ -73,5 +75,5 @@
     def listPrinters(self) :
         """Returns a list of tuples (queuename, deviceuri) for all existing print queues."""
-        self.logdebug("Extracting all print queues.")
+        self.printInfo("Extracting all print queues.")
         result = os.popen("lpstat -v", "r")
         lines = result.readlines()
@@ -87,13 +89,11 @@
     def listUsers(self, uidmin, uidmax) :    
         """Returns a list of usernames whose uids are between uidmin and uidmax."""
-        self.logdebug("Extracting all users whose uid is between %s and %s." % (uidmin, uidmax))
+        self.printInfo("Extracting all users whose uid is between %s and %s." % (uidmin, uidmax))
         return [entry[0] for entry in pwd.getpwall() if uidmin <= entry[2] <= uidmax]
         
     def runCommand(self, command, dryrun) :    
         """Launches an external command."""
-        if dryrun :
-            self.printInfo("%s" % command)
-        else :    
-            self.logdebug("%s" % command)
+        self.printInfo("%s" % command)
+        if not dryrun :    
             os.system(command)
             
@@ -121,4 +121,11 @@
         if not names :
             names = ["*"]
+            
+        self.printInfo("Please be patient...")
+        dryrun = not options["force"]
+        if dryrun :
+            self.printInfo("Don't worry, the database WILL NOT BE MODIFIED.")
+        else :    
+            self.printInfo("Please WORRY NOW, the database WILL BE MODIFIED.")
             
         if not options["uidmin"] :    
@@ -144,5 +151,5 @@
                 except KeyError, msg :    
                     raise PyKotaToolError, _("Unknown username %s : %s") % (options["uidmax"], msg)
-                    
+        
         if uidmin > uidmax :            
             (uidmin, uidmax) = (uidmax, uidmin)
@@ -150,11 +157,12 @@
         printers = self.listPrinters()                    
         
-        print "Please be patient..."
-        
         if printers :
-            self.createPrinters(printers, options["dryrun"])
-            self.createUsers(users, options["dryrun"])
-        
-        print "Database initialized."
+            self.createPrinters(printers, dryrun)
+            self.createUsers(users, dryrun)
+        
+        if dryrun :
+            self.printInfo("Simulation terminated.")
+        else :    
+            self.printInfo("Database initialized !")
                     
                      
@@ -162,6 +170,6 @@
     retcode = 0
     try :
-        short_options = "hvdu:U:"
-        long_options = ["help", "version", "dryrun", "uidmin=", "uidmax="]
+        short_options = "hvfu:U:"
+        long_options = ["help", "version", "force", "uidmin=", "uidmax="]
         
         # Initializes the command line tool
@@ -178,5 +186,5 @@
         options["help"] = options["h"] or options["help"]
         options["version"] = options["v"] or options["version"]
-        options["dryrun"] = options["d"] or options["dryrun"]
+        options["force"] = options["f"] or options["force"]
         options["uidmin"] = options["u"] or options["uidmin"]
         options["uidmax"] = options["U"] or options["uidmax"]
Index: pykota/trunk/NEWS
===================================================================
--- pykota/trunk/NEWS (revision 2425)
+++ pykota/trunk/NEWS (revision 2432)
@@ -22,4 +22,10 @@
 PyKota NEWS :
        
+    - 1.23alpha27 :
+    
+        - Replaced the --dryrun command line option by the --force
+          command line option in pkturnkey, with exactly the opposite
+          effect (for security reasons).
+          
     - 1.23alpha26 :
     