Index: pykota/trunk/man/tr/autopykota.1
===================================================================
--- pykota/trunk/man/tr/autopykota.1 (revision 2420)
+++ pykota/trunk/man/tr/autopykota.1 (revision 2453)
@@ -2,7 +2,7 @@
 .TH AUTOPYKOTA "1" "septembre 2005" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
 .SH NOM
-autopykota \- page de manuel de autopykota 1.23alpha25_unofficial
+autopykota \- page de manuel de autopykota 1.23alpha30_unofficial
 .SH DESCRIPTION
-autopykota v1.23alpha25_unofficial (c) 2003, 2004, 2005 Jerome Alet \- alet@librelogiciel.com
+autopykota v1.23alpha30_unofficial (c) 2003, 2004, 2005 Jerome Alet \- alet@librelogiciel.com
 .PP
 A tool to automate user account creation and initial balance setting.
Index: pykota/trunk/man/tr/edpykota.1
===================================================================
--- pykota/trunk/man/tr/edpykota.1 (revision 2420)
+++ pykota/trunk/man/tr/edpykota.1 (revision 2453)
@@ -2,7 +2,7 @@
 .TH EDPYKOTA "1" "septembre 2005" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
 .SH NOM
-edpykota \- page de manuel de edpykota 1.23alpha25_unofficial
+edpykota \- page de manuel de edpykota 1.23alpha30_unofficial
 .SH DESCRIPTION
-edpykota v1.23alpha25_unofficial (c) 2003, 2004, 2005 Jerome Alet \- alet@librelogiciel.com
+edpykota v1.23alpha30_unofficial (c) 2003, 2004, 2005 Jerome Alet \- alet@librelogiciel.com
 .PP
 A Print Quota editor for PyKota.
@@ -83,4 +83,5 @@
 \fB\-n\fR | \fB\-\-noquota\fR
 Doesn't set a quota but only does accounting.
+This is the same as \fB\-\-limitby\fR noquota.
 .TP
 \fB\-r\fR | \fB\-\-reset\fR
@@ -98,8 +99,14 @@
 by its account balance or by its page quota.
 The default value is 'quota'. Allowed values
-are 'quota' 'balance' 'quota\-then\-balance' and
-\&'balance\-then\-quota'.
-WARNING : quota\-then\-balance and balance\-then\-quota
-are not yet implemented.
+are 'quota' 'balance' 'noquota' 'noprint'
+and 'nochange' :
+.IP
+\- quota : limit by number of pages per printer.
+\- balance : limit by number of credits in account.
+\- noquota : no limit, accounting still done.
+\- nochange : no limit, accounting not done.
+\- noprint : printing is denied.
+.IP
+NB : nochange and noprint are not supported for groups.
 .TP
 \fB\-b\fR | \fB\-\-balance\fR b
@@ -112,4 +119,9 @@
 Groups don't have a real balance, but the
 sum of their users' account balance.
+.TP
+\fB\-C\fR | \fB\-\-comment\fR txt
+Defines some informational text to be associated
+with a change to an user's account balance.
+Only meaningful if \fB\-b\fR | \fB\-\-balance\fR is also used.
 .TP
 \fB\-S\fR | \fB\-\-softlimit\fR sl
Index: pykota/trunk/man/tr/pkbanner.1
===================================================================
--- pykota/trunk/man/tr/pkbanner.1 (revision 2420)
+++ pykota/trunk/man/tr/pkbanner.1 (revision 2453)
@@ -2,7 +2,7 @@
 .TH PKBANNER "1" "septembre 2005" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
 .SH NOM
-pkbanner \- page de manuel de pkbanner 1.23alpha25_unofficial
+pkbanner \- page de manuel de pkbanner 1.23alpha30_unofficial
 .SH DESCRIPTION
-pkbanner v1.23alpha25_unofficial (c) 2003, 2004, 2005 Jerome Alet \- alet@librelogiciel.com
+pkbanner v1.23alpha30_unofficial (c) 2003, 2004, 2005 Jerome Alet \- alet@librelogiciel.com
 .PP
 Generates banners.
Index: pykota/trunk/man/tr/pkprinters.1
===================================================================
--- pykota/trunk/man/tr/pkprinters.1 (revision 2420)
+++ pykota/trunk/man/tr/pkprinters.1 (revision 2453)
@@ -2,7 +2,7 @@
 .TH PKPRINTERS "1" "septembre 2005" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
 .SH NOM
-pkprinters \- page de manuel de pkprinters 1.23alpha25_unofficial
+pkprinters \- page de manuel de pkprinters 1.23alpha30_unofficial
 .SH DESCRIPTION
-pkprinters v1.23alpha25_unofficial (c) 2003, 2004, 2005 Jerome Alet \- alet@librelogiciel.com
+pkprinters v1.23alpha30_unofficial (c) 2003, 2004, 2005 Jerome Alet \- alet@librelogiciel.com
 .PP
 A Printers Manager for PyKota.
Index: pykota/trunk/man/tr/pykotme.1
===================================================================
--- pykota/trunk/man/tr/pykotme.1 (revision 2420)
+++ pykota/trunk/man/tr/pykotme.1 (revision 2453)
@@ -2,7 +2,7 @@
 .TH PYKOTME "1" "septembre 2005" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
 .SH NOM
-pykotme \- page de manuel de pykotme 1.23alpha25_unofficial
+pykotme \- page de manuel de pykotme 1.23alpha30_unofficial
 .SH DESCRIPTION
-pykotme v1.23alpha25_unofficial (c) 2003, 2004, 2005 Jerome Alet \- alet@librelogiciel.com
+pykotme v1.23alpha30_unofficial (c) 2003, 2004, 2005 Jerome Alet \- alet@librelogiciel.com
 .PP
 Gives print quotes to users.
Index: pykota/trunk/man/tr/pykosd.1
===================================================================
--- pykota/trunk/man/tr/pykosd.1 (revision 2420)
+++ pykota/trunk/man/tr/pykosd.1 (revision 2453)
@@ -2,7 +2,7 @@
 .TH PYKOSD "1" "septembre 2005" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
 .SH NOM
-pykosd \- page de manuel de pykosd 1.23alpha25_unofficial
+pykosd \- page de manuel de pykosd 1.23alpha30_unofficial
 .SH DESCRIPTION
-pykosd v1.23alpha25_unofficial (c) 2003, 2004, 2005 Jerome Alet \- alet@librelogiciel.com
+pykosd v1.23alpha30_unofficial (c) 2003, 2004, 2005 Jerome Alet \- alet@librelogiciel.com
 .PP
 An OSD quota monitor for PyKota.
Index: pykota/trunk/man/tr/pkturnkey.1
===================================================================
--- pykota/trunk/man/tr/pkturnkey.1 (revision 2435)
+++ pykota/trunk/man/tr/pkturnkey.1 (revision 2453)
@@ -2,7 +2,7 @@
 .TH PKTURNKEY "1" "septembre 2005" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
 .SH NOM
-pkturnkey \- page de manuel de pkturnkey 1.23alpha28_unofficial
+pkturnkey \- page de manuel de pkturnkey 1.23alpha30_unofficial
 .SH DESCRIPTION
-pkturnkey v1.23alpha28_unofficial (c) 2003, 2004, 2005 Jerome Alet \- alet@librelogiciel.com
+pkturnkey v1.23alpha30_unofficial (c) 2003, 2004, 2005 Jerome Alet \- alet@librelogiciel.com
 .PP
 A turn key tool for PyKota. When launched, this command will initialize
Index: pykota/trunk/man/tr/dumpykota.1
===================================================================
--- pykota/trunk/man/tr/dumpykota.1 (revision 2420)
+++ pykota/trunk/man/tr/dumpykota.1 (revision 2453)
@@ -2,7 +2,7 @@
 .TH DUMPYKOTA "1" "septembre 2005" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
 .SH NOM
-dumpykota \- page de manuel de dumpykota 1.23alpha25_unofficial
+dumpykota \- page de manuel de dumpykota 1.23alpha30_unofficial
 .SH DESCRIPTION
-dumpykota v1.23alpha25_unofficial (c) 2003, 2004, 2005 Jerome Alet \- alet@librelogiciel.com
+dumpykota v1.23alpha30_unofficial (c) 2003, 2004, 2005 Jerome Alet \- alet@librelogiciel.com
 .PP
 Dumps PyKota database's content.
Index: pykota/trunk/man/tr/pkhint.1
===================================================================
--- pykota/trunk/man/tr/pkhint.1 (revision 2420)
+++ pykota/trunk/man/tr/pkhint.1 (revision 2453)
@@ -2,7 +2,7 @@
 .TH PKHINT "1" "septembre 2005" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
 .SH NOM
-pkhint \- page de manuel de pkhint 1.23alpha25_unofficial
+pkhint \- page de manuel de pkhint 1.23alpha30_unofficial
 .SH DESCRIPTION
-pkhint v1.23alpha25_unofficial (c) 2003, 2004, 2005 Jerome Alet \- alet@librelogiciel.com
+pkhint v1.23alpha30_unofficial (c) 2003, 2004, 2005 Jerome Alet \- alet@librelogiciel.com
 .PP
 A tool to give hints on what accounting method is best for each printer.
Index: pykota/trunk/man/tr/pkmail.1
===================================================================
--- pykota/trunk/man/tr/pkmail.1 (revision 2420)
+++ pykota/trunk/man/tr/pkmail.1 (revision 2453)
@@ -2,7 +2,7 @@
 .TH PKMAIL "1" "septembre 2005" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
 .SH NOM
-pkmail \- page de manuel de pkmail 1.23alpha25_unofficial
+pkmail \- page de manuel de pkmail 1.23alpha30_unofficial
 .SH DESCRIPTION
-pkmail v1.23alpha25_unofficial (c) 2003, 2004, 2005 Jerome Alet \- alet@librelogiciel.com
+pkmail v1.23alpha30_unofficial (c) 2003, 2004, 2005 Jerome Alet \- alet@librelogiciel.com
 .PP
 Email gateway for PyKota.
Index: pykota/trunk/man/tr/repykota.1
===================================================================
--- pykota/trunk/man/tr/repykota.1 (revision 2420)
+++ pykota/trunk/man/tr/repykota.1 (revision 2453)
@@ -2,7 +2,7 @@
 .TH REPYKOTA "1" "septembre 2005" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
 .SH NOM
-repykota \- page de manuel de repykota 1.23alpha25_unofficial
+repykota \- page de manuel de repykota 1.23alpha30_unofficial
 .SH DESCRIPTION
-repykota v1.23alpha25_unofficial (c) 2003, 2004, 2005 Jerome Alet \- alet@librelogiciel.com
+repykota v1.23alpha30_unofficial (c) 2003, 2004, 2005 Jerome Alet \- alet@librelogiciel.com
 .PP
 Generates print quota reports.
@@ -26,4 +26,8 @@
 \fB\-g\fR | \fB\-\-groups\fR
 Generates a report on group quota instead of users.
+.TP
+\fB\-i\fR | \fB\-\-ingroups\fR g1[,g2...]
+Only lists users who are members of these
+groups. Reserved to PyKota Administrators.
 .TP
 \fB\-P\fR | \fB\-\-printer\fR p
Index: pykota/trunk/man/tr/warnpykota.1
===================================================================
--- pykota/trunk/man/tr/warnpykota.1 (revision 2420)
+++ pykota/trunk/man/tr/warnpykota.1 (revision 2453)
@@ -2,7 +2,7 @@
 .TH WARNPYKOTA "1" "septembre 2005" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
 .SH NOM
-warnpykota \- page de manuel de warnpykota 1.23alpha25_unofficial
+warnpykota \- page de manuel de warnpykota 1.23alpha30_unofficial
 .SH DESCRIPTION
-warnpykota v1.23alpha25_unofficial (c) 2003, 2004, 2005 Jerome Alet \- alet@librelogiciel.com
+warnpykota v1.23alpha30_unofficial (c) 2003, 2004, 2005 Jerome Alet \- alet@librelogiciel.com
 .PP
 Sends mail to users over print quota.